
// 笛卡尔积
export function descartes(...args) {
  if (args.length < 2) return args

  if (args.length === 2) {
    const [a, b] = args
    return a.map(x => ([x, b])).reduce((acc, x) => {
      const [i, j] = x
      return [
        ...acc,
        ...(j.map(y => ([i, y])))
      ]
    }, [])
  } else {
    const [a, ...b] = args
    const tmp = descartes(...b)
    return descartes(a, tmp).map(([a, b]) => ([a, ...b]))
  }
}
